]>
Commit | Line | Data |
---|---|---|
f2352877 | 1 | #!/bin/bash |
0777eafb WD |
2 | # Tool mainly for U-Boot Quality Assurance: build one or more board |
3 | # configurations with minimal verbosity, showing only warnings and | |
4 | # errors. | |
eca3aeb3 WD |
5 | # |
6 | # SPDX-License-Identifier: GPL-2.0+ | |
0777eafb | 7 | |
d8e392d9 MF |
8 | usage() |
9 | { | |
10 | # if exiting with 0, write to stdout, else write to stderr | |
11 | local ret=${1:-0} | |
12 | [ "${ret}" -eq 1 ] && exec 1>&2 | |
13 | cat <<-EOF | |
14 | Usage: MAKEALL [options] [--] [boards-to-build] | |
15 | ||
16 | Options: | |
17 | -a ARCH, --arch ARCH Build all boards with arch ARCH | |
18 | -c CPU, --cpu CPU Build all boards with cpu CPU | |
19 | -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR | |
20 | -s SOC, --soc SOC Build all boards with soc SOC | |
4d1584bd | 21 | -b BOARD, --board BOARD Build all boards with board name BOARD |
7f79c6f2 | 22 | -l, --list List all targets to be built |
9b96c6b1 MV |
23 | -m, --maintainers List all targets and maintainer email |
24 | -M, --mails List all targets and all affilated emails | |
33f336d5 | 25 | -C, --check Enable build checking |
08510204 JH |
26 | -n, --continue Continue (skip boards already built) |
27 | -r, --rebuild-errors Rebuild any boards that errored | |
d8e392d9 MF |
28 | -h, --help This help output |
29 | ||
30 | Selections by these options are logically ANDed; if the same option | |
31 | is used repeatedly, such selections are ORed. So "-v FOO -v BAR" | |
32 | will select all configurations where the vendor is either FOO or | |
33 | BAR. Any additional arguments specified on the command line are | |
34 | always build additionally. See the boards.cfg file for more info. | |
35 | ||
36 | If no boards are specified, then the default is "powerpc". | |
37 | ||
38 | Environment variables: | |
39 | BUILD_NCPUS number of parallel make jobs (default: auto) | |
40 | CROSS_COMPILE cross-compiler toolchain prefix (default: "") | |
47104c37 | 41 | CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for |
93e14596 WD |
42 | architecture "ARCH". Substitute "ARCH" for any |
43 | supported architecture (default: "") | |
d8e392d9 MF |
44 | MAKEALL_LOGDIR output all logs to here (default: ./LOG/) |
45 | BUILD_DIR output build directory (default: ./) | |
f588bb03 | 46 | BUILD_NBUILDS number of parallel targets (default: 1) |
d8e392d9 MF |
47 | |
48 | Examples: | |
49 | - build all Power Architecture boards: | |
50 | MAKEALL -a powerpc | |
51 | MAKEALL --arch powerpc | |
52 | MAKEALL powerpc | |
53 | - build all PowerPC boards manufactured by vendor "esd": | |
54 | MAKEALL -a powerpc -v esd | |
55 | - build all PowerPC boards manufactured either by "keymile" or "siemens": | |
56 | MAKEALL -a powerpc -v keymile -v siemens | |
57 | - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards: | |
58 | MAKEALL -c mpc83xx -v freescale 4xx | |
59 | EOF | |
60 | exit ${ret} | |
61 | } | |
62 | ||
4d1584bd MY |
63 | SHORT_OPTS="ha:c:v:s:b:lmMCnr" |
64 | LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors" | |
0777eafb WD |
65 | |
66 | # Option processing based on util-linux-2.13/getopt-parse.bash | |
67 | ||
071bc923 | 68 | # Note that we use `"$@"' to let each command-line parameter expand to a |
0777eafb WD |
69 | # separate word. The quotes around `$@' are essential! |
70 | # We need TEMP as the `eval set --' would nuke the return value of | |
71 | # getopt. | |
72 | TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \ | |
73 | -n 'MAKEALL' -- "$@"` | |
74 | ||
d8e392d9 | 75 | [ $? != 0 ] && usage 1 |
0777eafb WD |
76 | |
77 | # Note the quotes around `$TEMP': they are essential! | |
78 | eval set -- "$TEMP" | |
79 | ||
80 | SELECTED='' | |
7f79c6f2 | 81 | ONLY_LIST='' |
9b96c6b1 MV |
82 | PRINT_MAINTS='' |
83 | MAINTAINERS_ONLY='' | |
08510204 JH |
84 | CONTINUE='' |
85 | REBUILD_ERRORS='' | |
0777eafb WD |
86 | |
87 | while true ; do | |
88 | case "$1" in | |
89 | -a|--arch) | |
90 | # echo "Option ARCH: argument \`$2'" | |
91 | if [ "$opt_a" ] ; then | |
92 | opt_a="${opt_a%)} || \$2 == \"$2\")" | |
93 | else | |
94 | opt_a="(\$2 == \"$2\")" | |
95 | fi | |
96 | SELECTED='y' | |
97 | shift 2 ;; | |
98 | -c|--cpu) | |
99 | # echo "Option CPU: argument \`$2'" | |
100 | if [ "$opt_c" ] ; then | |
aa2e279d | 101 | opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)" |
0777eafb | 102 | else |
aa2e279d | 103 | opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)" |
0777eafb WD |
104 | fi |
105 | SELECTED='y' | |
106 | shift 2 ;; | |
107 | -s|--soc) | |
108 | # echo "Option SoC: argument \`$2'" | |
109 | if [ "$opt_s" ] ; then | |
27af930e | 110 | opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)" |
0777eafb | 111 | else |
27af930e | 112 | opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)" |
0777eafb WD |
113 | fi |
114 | SELECTED='y' | |
115 | shift 2 ;; | |
116 | -v|--vendor) | |
117 | # echo "Option VENDOR: argument \`$2'" | |
118 | if [ "$opt_v" ] ; then | |
119 | opt_v="${opt_v%)} || \$5 == \"$2\")" | |
120 | else | |
121 | opt_v="(\$5 == \"$2\")" | |
122 | fi | |
123 | SELECTED='y' | |
124 | shift 2 ;; | |
4d1584bd MY |
125 | -b|--board) |
126 | # echo "Option BOARD: argument \`$2'" | |
127 | if [ "$opt_b" ] ; then | |
128 | opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")" | |
129 | else | |
130 | # We need to check the 7th field too | |
131 | # for boards whose 6th field is "-" | |
132 | opt_b="(\$6 == \"$2\" || \$7 == \"$2\")" | |
133 | fi | |
134 | SELECTED='y' | |
135 | shift 2 ;; | |
33f336d5 KP |
136 | -C|--check) |
137 | CHECK='C=1' | |
138 | shift ;; | |
08510204 JH |
139 | -n|--continue) |
140 | CONTINUE='y' | |
141 | shift ;; | |
142 | -r|--rebuild-errors) | |
143 | REBUILD_ERRORS='y' | |
144 | shift ;; | |
7f79c6f2 MV |
145 | -l|--list) |
146 | ONLY_LIST='y' | |
147 | shift ;; | |
9b96c6b1 MV |
148 | -m|--maintainers) |
149 | ONLY_LIST='y' | |
150 | PRINT_MAINTS='y' | |
151 | MAINTAINERS_ONLY='y' | |
152 | shift ;; | |
153 | -M|--mails) | |
154 | ONLY_LIST='y' | |
155 | PRINT_MAINTS='y' | |
156 | shift ;; | |
d8e392d9 MF |
157 | -h|--help) |
158 | usage ;; | |
0777eafb WD |
159 | --) |
160 | shift ; break ;; | |
161 | *) | |
162 | echo "Internal error!" >&2 ; exit 1 ;; | |
163 | esac | |
164 | done | |
e18fd940 MY |
165 | |
166 | GNU_MAKE=$(scripts/show-gnu-make) || { | |
167 | echo "GNU Make not found" >&2 | |
168 | exit 1 | |
169 | } | |
170 | ||
0777eafb WD |
171 | # echo "Remaining arguments:" |
172 | # for arg do echo '--> '"\`$arg'" ; done | |
173 | ||
94ab8f41 MY |
174 | tools/genboardscfg.py || { |
175 | echo "Failed to generate boards.cfg" >&2 | |
176 | exit 1 | |
177 | } | |
bb6da87d | 178 | |
0777eafb WD |
179 | FILTER="\$1 !~ /^#/" |
180 | [ "$opt_a" ] && FILTER="${FILTER} && $opt_a" | |
181 | [ "$opt_c" ] && FILTER="${FILTER} && $opt_c" | |
182 | [ "$opt_s" ] && FILTER="${FILTER} && $opt_s" | |
183 | [ "$opt_v" ] && FILTER="${FILTER} && $opt_v" | |
4d1584bd | 184 | [ "$opt_b" ] && FILTER="${FILTER} && $opt_b" |
0777eafb WD |
185 | |
186 | if [ "$SELECTED" ] ; then | |
27af930e | 187 | SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg) |
cd57b0bb PT |
188 | |
189 | # Make sure some boards from boards.cfg are actually found | |
190 | if [ -z "$SELECTED" ] ; then | |
191 | echo "Error: No boards selected, invalid arguments" | |
192 | exit 1 | |
193 | fi | |
0777eafb WD |
194 | fi |
195 | ||
196 | ######################################################################### | |
197 | ||
40a28f08 PT |
198 | # Print statistics when we exit |
199 | trap exit 1 2 3 15 | |
200 | trap print_stats 0 | |
201 | ||
7fa6a2f3 WD |
202 | # Determine number of CPU cores if no default was set |
203 | : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"} | |
204 | ||
205 | if [ "$BUILD_NCPUS" -gt 1 ] | |
206 | then | |
55f786d8 | 207 | JOBS="-j $((BUILD_NCPUS + 1))" |
7fa6a2f3 WD |
208 | else |
209 | JOBS="" | |
210 | fi | |
211 | ||
f9328639 MB |
212 | if [ "${MAKEALL_LOGDIR}" ] ; then |
213 | LOG_DIR=${MAKEALL_LOGDIR} | |
214 | else | |
215 | LOG_DIR="LOG" | |
216 | fi | |
887e2ec9 | 217 | |
f588bb03 AF |
218 | : ${BUILD_NBUILDS:=1} |
219 | BUILD_MANY=0 | |
220 | ||
221 | if [ "${BUILD_NBUILDS}" -gt 1 ] ; then | |
222 | BUILD_MANY=1 | |
223 | : ${BUILD_DIR:=./build} | |
224 | mkdir -p "${BUILD_DIR}/ERR" | |
225 | find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} + | |
f9328639 MB |
226 | fi |
227 | ||
f588bb03 AF |
228 | : ${BUILD_DIR:=.} |
229 | ||
230 | OUTPUT_PREFIX="${BUILD_DIR}" | |
231 | ||
232 | [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1 | |
08510204 JH |
233 | if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then |
234 | find "${LOG_DIR}/" -type f -exec rm -f {} + | |
235 | fi | |
7ebf7443 WD |
236 | |
237 | LIST="" | |
238 | ||
40a28f08 PT |
239 | # Keep track of the number of builds and errors |
240 | ERR_CNT=0 | |
241 | ERR_LIST="" | |
b86a475c JH |
242 | WRN_CNT=0 |
243 | WRN_LIST="" | |
40a28f08 | 244 | TOTAL_CNT=0 |
08510204 | 245 | SKIP_CNT=0 |
f588bb03 AF |
246 | CURRENT_CNT=0 |
247 | OLDEST_IDX=1 | |
f2352877 | 248 | RC=0 |
40a28f08 | 249 | |
9ec49f8f | 250 | # Helper funcs for parsing boards.cfg |
8948794a | 251 | targets_by_field() |
9ec49f8f | 252 | { |
8e5a2d42 MY |
253 | field=$1 |
254 | regexp=$2 | |
255 | ||
256 | awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \ | |
257 | boards.cfg | |
9ec49f8f | 258 | } |
8e5a2d42 | 259 | |
8948794a MY |
260 | targets_by_arch() { targets_by_field 2 "$@" ; } |
261 | targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; } | |
262 | targets_by_soc() { targets_by_field 4 "$@" ; } | |
9ec49f8f | 263 | |
0db5bca8 WD |
264 | ######################################################################### |
265 | ## MPC5xx Systems | |
266 | ######################################################################### | |
267 | ||
8948794a | 268 | LIST_5xx="$(targets_by_cpu mpc5xx)" |
0db5bca8 | 269 | |
945af8d7 WD |
270 | ######################################################################### |
271 | ## MPC5xxx Systems | |
272 | ######################################################################### | |
273 | ||
8948794a | 274 | LIST_5xxx="$(targets_by_cpu mpc5xxx)" |
945af8d7 | 275 | |
8993e54b RJ |
276 | ######################################################################### |
277 | ## MPC512x Systems | |
278 | ######################################################################### | |
279 | ||
8948794a | 280 | LIST_512x="$(targets_by_cpu mpc512x)" |
945af8d7 | 281 | |
7ebf7443 WD |
282 | ######################################################################### |
283 | ## MPC8xx Systems | |
284 | ######################################################################### | |
9ec49f8f | 285 | |
8948794a | 286 | LIST_8xx="$(targets_by_cpu mpc8xx)" |
7ebf7443 WD |
287 | |
288 | ######################################################################### | |
289 | ## PPC4xx Systems | |
290 | ######################################################################### | |
291 | ||
8948794a | 292 | LIST_4xx="$(targets_by_cpu ppc4xx)" |
7ebf7443 WD |
293 | |
294 | ######################################################################### | |
295 | ## MPC824x Systems | |
296 | ######################################################################### | |
297 | ||
8948794a | 298 | LIST_824x="$(targets_by_cpu mpc824x)" |
592c5cab | 299 | |
7ebf7443 | 300 | ######################################################################### |
7aa78614 | 301 | ## MPC8260 Systems (includes 8250, 8255 etc.) |
7ebf7443 WD |
302 | ######################################################################### |
303 | ||
8948794a | 304 | LIST_8260="$(targets_by_cpu mpc8260)" |
7ebf7443 | 305 | |
f046ccd1 EL |
306 | ######################################################################### |
307 | ## MPC83xx Systems (includes 8349, etc.) | |
308 | ######################################################################### | |
309 | ||
8948794a | 310 | LIST_83xx="$(targets_by_cpu mpc83xx)" |
f046ccd1 | 311 | |
42d1f039 WD |
312 | ######################################################################### |
313 | ## MPC85xx Systems (includes 8540, 8560 etc.) | |
314 | ######################################################################### | |
315 | ||
8948794a | 316 | LIST_85xx="$(targets_by_cpu mpc85xx)" |
42d1f039 | 317 | |
822d5536 JL |
318 | ######################################################################### |
319 | ## MPC86xx Systems | |
320 | ######################################################################### | |
321 | ||
8948794a | 322 | LIST_86xx="$(targets_by_cpu mpc86xx)" |
822d5536 | 323 | |
7ebf7443 WD |
324 | ######################################################################### |
325 | ## 74xx/7xx Systems | |
326 | ######################################################################### | |
327 | ||
8948794a | 328 | LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)" |
7ebf7443 | 329 | |
d9a42c0a WD |
330 | ######################################################################### |
331 | ## PowerPC groups | |
332 | ######################################################################### | |
333 | ||
334 | LIST_TSEC=" \ | |
335 | ${LIST_83xx} \ | |
336 | ${LIST_85xx} \ | |
337 | ${LIST_86xx} \ | |
338 | " | |
339 | ||
a47a12be | 340 | LIST_powerpc=" \ |
fb56579f | 341 | ${LIST_5xx} \ |
3deca9d4 | 342 | ${LIST_512x} \ |
fb56579f KP |
343 | ${LIST_5xxx} \ |
344 | ${LIST_8xx} \ | |
fb56579f KP |
345 | ${LIST_824x} \ |
346 | ${LIST_8260} \ | |
347 | ${LIST_83xx} \ | |
348 | ${LIST_85xx} \ | |
349 | ${LIST_86xx} \ | |
350 | ${LIST_4xx} \ | |
2ae18241 | 351 | ${LIST_74xx_7xx}\ |
fb56579f | 352 | " |
7ebf7443 | 353 | |
a47a12be SR |
354 | # Alias "ppc" -> "powerpc" to not break compatibility with older scripts |
355 | # still using "ppc" instead of "powerpc" | |
356 | LIST_ppc=" \ | |
357 | ${LIST_powerpc} \ | |
358 | " | |
359 | ||
7ebf7443 WD |
360 | ######################################################################### |
361 | ## StrongARM Systems | |
362 | ######################################################################### | |
363 | ||
8948794a | 364 | LIST_SA="$(targets_by_cpu sa1100)" |
7ebf7443 | 365 | |
cce5d210 AM |
366 | ######################################################################### |
367 | ## ARM7 Systems | |
368 | ######################################################################### | |
369 | ||
8948794a | 370 | LIST_ARM7="$(targets_by_cpu arm720t)" |
cce5d210 | 371 | |
7ebf7443 WD |
372 | ######################################################################### |
373 | ## ARM9 Systems | |
374 | ######################################################################### | |
375 | ||
8948794a MY |
376 | LIST_ARM9="$(targets_by_cpu arm920t) \ |
377 | $(targets_by_cpu arm926ejs) \ | |
378 | $(targets_by_cpu arm946es) \ | |
6f21347d | 379 | " |
7ebf7443 | 380 | |
8ed96046 WD |
381 | ######################################################################### |
382 | ## ARM11 Systems | |
383 | ######################################################################### | |
8948794a MY |
384 | LIST_ARM11="$(targets_by_cpu arm1136) \ |
385 | $(targets_by_cpu arm1176) \ | |
cce5d210 | 386 | " |
8ed96046 | 387 | |
f904cdbb | 388 | ######################################################################### |
f56348af | 389 | ## ARMV7 Systems |
f904cdbb | 390 | ######################################################################### |
f37586bb | 391 | |
8948794a | 392 | LIST_ARMV7="$(targets_by_cpu armv7)" |
f904cdbb | 393 | |
2475e634 DF |
394 | ######################################################################### |
395 | ## ARMV8 Systems | |
396 | ######################################################################### | |
397 | ||
398 | LIST_ARMV8="$(targets_by_cpu armv8)" | |
399 | ||
602cac13 JCPV |
400 | ######################################################################### |
401 | ## AT91 Systems | |
402 | ######################################################################### | |
403 | ||
8948794a | 404 | LIST_at91="$(targets_by_soc at91)" |
602cac13 | 405 | |
7ebf7443 WD |
406 | ######################################################################### |
407 | ## Xscale Systems | |
408 | ######################################################################### | |
409 | ||
8948794a | 410 | LIST_pxa="$(targets_by_cpu pxa)" |
7ebf7443 | 411 | |
24dede48 SR |
412 | ######################################################################### |
413 | ## SPEAr Systems | |
414 | ######################################################################### | |
415 | ||
8948794a | 416 | LIST_spear="$(targets_by_soc spear)" |
24dede48 | 417 | |
d9a42c0a WD |
418 | ######################################################################### |
419 | ## ARM groups | |
420 | ######################################################################### | |
2d5b561e | 421 | |
2475e634 DF |
422 | LIST_arm="$(targets_by_arch arm | \ |
423 | for ARMV8_TARGET in $LIST_ARMV8; \ | |
424 | do sed "/$ARMV8_TARGET/d"; \ | |
425 | done) \ | |
426 | " | |
7ebf7443 | 427 | |
c021880a | 428 | ######################################################################### |
b62bdffb | 429 | ## MIPS Systems (default = big endian) |
c021880a WD |
430 | ######################################################################### |
431 | ||
ed638b6a | 432 | LIST_mips="$(targets_by_arch mips)" |
c021880a | 433 | |
deddf5d2 SK |
434 | ######################################################################### |
435 | ## OpenRISC Systems | |
436 | ######################################################################### | |
437 | ||
8948794a | 438 | LIST_openrisc="$(targets_by_arch openrisc)" |
b62bdffb | 439 | |
7a8e9bed | 440 | ######################################################################### |
fea25720 | 441 | ## x86 Systems |
7a8e9bed WD |
442 | ######################################################################### |
443 | ||
8948794a | 444 | LIST_x86="$(targets_by_arch x86)" |
7a8e9bed | 445 | |
5c952cf0 WD |
446 | ######################################################################### |
447 | ## Nios-II Systems | |
448 | ######################################################################### | |
449 | ||
8948794a | 450 | LIST_nios2="$(targets_by_arch nios2)" |
5c952cf0 | 451 | |
857cad37 WD |
452 | ######################################################################### |
453 | ## MicroBlaze Systems | |
454 | ######################################################################### | |
455 | ||
8948794a | 456 | LIST_microblaze="$(targets_by_arch microblaze)" |
857cad37 | 457 | |
f8c3b4f3 ZL |
458 | ######################################################################### |
459 | ## ColdFire Systems | |
460 | ######################################################################### | |
461 | ||
8948794a | 462 | LIST_m68k="$(targets_by_arch m68k)" |
c13f47b0 | 463 | LIST_coldfire=${LIST_m68k} |
f8c3b4f3 | 464 | |
6ccec449 WD |
465 | ######################################################################### |
466 | ## AVR32 Systems | |
467 | ######################################################################### | |
468 | ||
8948794a | 469 | LIST_avr32="$(targets_by_arch avr32)" |
6ccec449 | 470 | |
ef26a08f AL |
471 | ######################################################################### |
472 | ## Blackfin Systems | |
473 | ######################################################################### | |
474 | ||
8948794a | 475 | LIST_blackfin="$(targets_by_arch blackfin)" |
ef26a08f | 476 | |
c7144373 JCPV |
477 | ######################################################################### |
478 | ## SH Systems | |
479 | ######################################################################### | |
480 | ||
8948794a MY |
481 | LIST_sh2="$(targets_by_cpu sh2)" |
482 | LIST_sh3="$(targets_by_cpu sh3)" | |
483 | LIST_sh4="$(targets_by_cpu sh4)" | |
d9a42c0a | 484 | |
8948794a | 485 | LIST_sh="$(targets_by_arch sh)" |
c7144373 | 486 | |
c2f02da2 DH |
487 | ######################################################################### |
488 | ## SPARC Systems | |
489 | ######################################################################### | |
490 | ||
8948794a | 491 | LIST_sparc="$(targets_by_arch sparc)" |
7ebf7443 | 492 | |
5f1719c1 ML |
493 | ######################################################################### |
494 | ## NDS32 Systems | |
495 | ######################################################################### | |
496 | ||
8948794a | 497 | LIST_nds32="$(targets_by_arch nds32)" |
5f1719c1 | 498 | |
568c1fad AB |
499 | ######################################################################### |
500 | ## ARC Systems | |
501 | ######################################################################### | |
502 | ||
503 | LIST_arc="$(targets_by_arch arc)" | |
504 | ||
7ebf7443 WD |
505 | #----------------------------------------------------------------------- |
506 | ||
9b96c6b1 MV |
507 | get_target_location() { |
508 | local target=$1 | |
509 | local BOARD_NAME="" | |
510 | local CONFIG_NAME="" | |
511 | local board="" | |
512 | local vendor="" | |
513 | ||
514 | # Automatic mode | |
23d6410c | 515 | local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg` |
9b96c6b1 MV |
516 | if [ -z "${line}" ] ; then echo "" ; return ; fi |
517 | ||
518 | set ${line} | |
519 | ||
bb6da87d | 520 | CONFIG_NAME="${7%_defconfig}" |
9b96c6b1 | 521 | |
bb6da87d | 522 | [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}" |
9b96c6b1 | 523 | |
27af930e AA |
524 | if [ $# -gt 5 ]; then |
525 | if [ "$6" = "-" ] ; then | |
526 | board=${BOARD_NAME} | |
527 | else | |
528 | board="$6" | |
529 | fi | |
9b96c6b1 MV |
530 | fi |
531 | ||
532 | [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5" | |
27af930e AA |
533 | [ $# -gt 6 ] && [ "$8" != "-" ] && { |
534 | tmp="${8%:*}" | |
9b96c6b1 MV |
535 | if [ "$tmp" ] ; then |
536 | CONFIG_NAME="$tmp" | |
537 | fi | |
538 | } | |
539 | ||
540 | # Assign board directory to BOARDIR variable | |
27af930e | 541 | if [ "${vendor}" == "-" ] ; then |
9b96c6b1 MV |
542 | BOARDDIR=${board} |
543 | else | |
544 | BOARDDIR=${vendor}/${board} | |
545 | fi | |
546 | ||
27af930e | 547 | echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}" |
9b96c6b1 MV |
548 | } |
549 | ||
550 | get_target_maintainers() { | |
27af930e | 551 | local name=`echo $1 | cut -d : -f 3` |
9b96c6b1 | 552 | |
23d6410c | 553 | local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg` |
27af930e | 554 | if [ -z "${line}" ]; then |
9b96c6b1 MV |
555 | echo "" |
556 | return ; | |
557 | fi | |
558 | ||
27af930e AA |
559 | local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'` |
560 | [ "$mails" == "-" ] && mails="" | |
561 | echo "$mails" | |
9b96c6b1 MV |
562 | } |
563 | ||
47104c37 AM |
564 | get_target_arch() { |
565 | local target=$1 | |
566 | ||
567 | # Automatic mode | |
54d1f504 | 568 | local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg` |
47104c37 AM |
569 | |
570 | if [ -z "${line}" ] ; then echo "" ; return ; fi | |
571 | ||
572 | set ${line} | |
573 | echo "$2" | |
574 | } | |
575 | ||
9b96c6b1 MV |
576 | list_target() { |
577 | if [ "$PRINT_MAINTS" != 'y' ] ; then | |
578 | echo "$1" | |
579 | return | |
580 | fi | |
581 | ||
582 | echo -n "$1:" | |
583 | ||
584 | local loc=`get_target_location $1` | |
585 | ||
586 | if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi | |
587 | ||
588 | local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"` | |
589 | ||
590 | if [ "$MAINTAINERS_ONLY" != 'y' ] ; then | |
591 | ||
592 | local dir=`echo ${loc} | cut -d ":" -f 2` | |
593 | local cfg=`echo ${loc} | cut -d ":" -f 1` | |
594 | local git_result=`git log --format=%aE board/${dir} \ | |
595 | include/configs/${cfg}.h | grep "@"` | |
596 | local git_result_recent=`echo ${git_result} | tr " " "\n" | \ | |
597 | head -n 3` | |
598 | local git_result_top=`echo ${git_result} | tr " " "\n" | \ | |
599 | sort | uniq -c | sort -nr | head -n 3 | \ | |
600 | sed "s/^ \+[0-9]\+ \+//"` | |
601 | ||
602 | echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \ | |
603 | sort -u | tr "\n" " " | sed "s/ $//" ; | |
604 | else | |
605 | echo -e "$maintainers_result" | sort -u | tr "\n" " " | \ | |
606 | sed "s/ $//" ; | |
607 | fi | |
608 | ||
609 | echo "" | |
610 | } | |
611 | ||
f588bb03 AF |
612 | # Each finished build will have a file called ${donep}${n}, |
613 | # where n is the index of the build. Each build | |
614 | # we've already noted as finished will have ${skipp}${n}. | |
615 | # The code managing the build process will use this information | |
616 | # to ensure that only BUILD_NBUILDS builds are in flight at once | |
617 | donep="${LOG_DIR}/._done_" | |
618 | skipp="${LOG_DIR}/._skip_" | |
619 | ||
c97d59cb JH |
620 | build_target_killed() { |
621 | echo "Aborted $target build." | |
622 | # Remove the logs for this board since it was aborted | |
623 | rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR | |
624 | exit | |
625 | } | |
626 | ||
7ebf7443 WD |
627 | build_target() { |
628 | target=$1 | |
f588bb03 AF |
629 | build_idx=$2 |
630 | ||
f50bf50d AF |
631 | if [ "$ONLY_LIST" == 'y' ] ; then |
632 | list_target ${target} | |
633 | return | |
634 | fi | |
635 | ||
f588bb03 AF |
636 | if [ $BUILD_MANY == 1 ] ; then |
637 | output_dir="${OUTPUT_PREFIX}/${target}" | |
638 | mkdir -p "${output_dir}" | |
c97d59cb | 639 | trap build_target_killed TERM |
f588bb03 AF |
640 | else |
641 | output_dir="${OUTPUT_PREFIX}" | |
642 | fi | |
643 | ||
47104c37 | 644 | target_arch=$(get_target_arch ${target}) |
c17b94ec | 645 | eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'` |
47104c37 | 646 | if [ "${cross_toolchain}" ] ; then |
e18fd940 | 647 | MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}" |
47104c37 | 648 | elif [ "${CROSS_COMPILE}" ] ; then |
e18fd940 | 649 | MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}" |
47104c37 | 650 | else |
e18fd940 | 651 | MAKE=$GNU_MAKE |
47104c37 AM |
652 | fi |
653 | ||
9e414032 MY |
654 | if [ "${output_dir}" != "." ] ; then |
655 | MAKE="${MAKE} O=${output_dir}" | |
656 | fi | |
657 | ||
fd18a89e | 658 | ${MAKE} mrproper >/dev/null |
bb6da87d MY |
659 | |
660 | echo "Building ${target} board..." | |
661 | ${MAKE} -s ${target}_defconfig >/dev/null | |
f9328639 | 662 | |
33f336d5 | 663 | ${MAKE} ${JOBS} ${CHECK} all \ |
f588bb03 | 664 | >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR |
f2352877 PT |
665 | |
666 | # Check for 'make' errors | |
667 | if [ ${PIPESTATUS[0]} -ne 0 ] ; then | |
668 | RC=1 | |
669 | fi | |
670 | ||
f588bb03 | 671 | if [ $BUILD_MANY == 1 ] ; then |
c97d59cb JH |
672 | trap - TERM |
673 | ||
7390643f | 674 | ${MAKE} -s clean |
f588bb03 AF |
675 | |
676 | if [ -s ${LOG_DIR}/${target}.ERR ] ; then | |
b86a475c | 677 | cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target} |
f588bb03 AF |
678 | else |
679 | rm ${LOG_DIR}/${target}.ERR | |
680 | fi | |
40a28f08 | 681 | else |
f588bb03 | 682 | if [ -s ${LOG_DIR}/${target}.ERR ] ; then |
b86a475c JH |
683 | if grep -iw error ${LOG_DIR}/${target}.ERR ; then |
684 | : $(( ERR_CNT += 1 )) | |
685 | ERR_LIST="${ERR_LIST} $target" | |
686 | else | |
687 | : $(( WRN_CNT += 1 )) | |
688 | WRN_LIST="${WRN_LIST} $target" | |
689 | fi | |
f588bb03 AF |
690 | else |
691 | rm ${LOG_DIR}/${target}.ERR | |
692 | fi | |
40a28f08 PT |
693 | fi |
694 | ||
f588bb03 AF |
695 | OBJS=${output_dir}/u-boot |
696 | if [ -e ${output_dir}/spl/u-boot-spl ]; then | |
697 | OBJS="${OBJS} ${output_dir}/spl/u-boot-spl" | |
0c185696 SW |
698 | fi |
699 | ||
700 | ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG | |
f588bb03 AF |
701 | |
702 | [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR" | |
703 | ||
f588bb03 | 704 | touch "${donep}${build_idx}" |
7ebf7443 | 705 | } |
f588bb03 AF |
706 | |
707 | manage_builds() { | |
708 | search_idx=${OLDEST_IDX} | |
f50bf50d AF |
709 | if [ "$ONLY_LIST" == 'y' ] ; then return ; fi |
710 | ||
f588bb03 AF |
711 | while true; do |
712 | if [ -e "${donep}${search_idx}" ] ; then | |
f588bb03 AF |
713 | : $(( CURRENT_CNT-- )) |
714 | [ ${OLDEST_IDX} -eq ${search_idx} ] && | |
715 | : $(( OLDEST_IDX++ )) | |
716 | ||
717 | # Only want to count it once | |
718 | rm -f "${donep}${search_idx}" | |
719 | touch "${skipp}${search_idx}" | |
720 | elif [ -e "${skipp}${search_idx}" ] ; then | |
721 | [ ${OLDEST_IDX} -eq ${search_idx} ] && | |
722 | : $(( OLDEST_IDX++ )) | |
723 | fi | |
f588bb03 AF |
724 | : $(( search_idx++ )) |
725 | if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then | |
f588bb03 AF |
726 | if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then |
727 | search_idx=${OLDEST_IDX} | |
728 | sleep 1 | |
729 | else | |
730 | break | |
731 | fi | |
732 | fi | |
733 | done | |
734 | } | |
735 | ||
9ec49f8f MF |
736 | build_targets() { |
737 | for t in "$@" ; do | |
738 | # If a LIST_xxx var exists, use it. But avoid variable | |
739 | # expansion in the eval when a board name contains certain | |
740 | # characters that the shell interprets. | |
741 | case ${t} in | |
742 | *[-+=]*) list= ;; | |
743 | *) list=$(eval echo '${LIST_'$t'}') ;; | |
744 | esac | |
745 | if [ -n "${list}" ] ; then | |
746 | build_targets ${list} | |
747 | else | |
f588bb03 AF |
748 | : $((TOTAL_CNT += 1)) |
749 | : $((CURRENT_CNT += 1)) | |
750 | rm -f "${donep}${TOTAL_CNT}" | |
751 | rm -f "${skipp}${TOTAL_CNT}" | |
08510204 JH |
752 | if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then |
753 | : $((SKIP_CNT += 1)) | |
754 | touch "${donep}${TOTAL_CNT}" | |
755 | elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then | |
756 | : $((SKIP_CNT += 1)) | |
757 | touch "${donep}${TOTAL_CNT}" | |
b594bd6a | 758 | else |
08510204 JH |
759 | if [ $BUILD_MANY == 1 ] ; then |
760 | build_target ${t} ${TOTAL_CNT} & | |
761 | else | |
762 | CUR_TGT="${t}" | |
763 | build_target ${t} ${TOTAL_CNT} | |
764 | CUR_TGT='' | |
765 | fi | |
b594bd6a | 766 | fi |
f588bb03 AF |
767 | fi |
768 | ||
769 | # We maintain a running count of all the builds we have done. | |
770 | # Each finished build will have a file called ${donep}${n}, | |
771 | # where n is the index of the build. Each build | |
772 | # we've already noted as finished will have ${skipp}${n}. | |
773 | # We track the current index via TOTAL_CNT, and the oldest | |
774 | # index. When we exceed the maximum number of parallel builds, | |
775 | # We look from oldest to current for builds that have completed, | |
776 | # and update the current count and oldest index as appropriate. | |
777 | # If we've gone through the entire list, wait a second, and | |
778 | # reprocess the entire list until we find a build that has | |
779 | # completed | |
780 | if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then | |
781 | manage_builds | |
9ec49f8f MF |
782 | fi |
783 | done | |
784 | } | |
7ebf7443 WD |
785 | |
786 | #----------------------------------------------------------------------- | |
787 | ||
f50bf50d | 788 | kill_children() { |
6bdd9f89 AB |
789 | local OS=$(uname -s) |
790 | local children="" | |
791 | case "${OS}" in | |
792 | "Darwin") | |
793 | # Mac OS X is known to have BSD style ps | |
794 | local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d") | |
795 | children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d") | |
796 | ;; | |
797 | *) | |
798 | # everything else tries the GNU style | |
799 | local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ') | |
800 | children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d") | |
801 | ;; | |
802 | esac | |
c97d59cb JH |
803 | |
804 | kill $children 2> /dev/null | |
805 | wait $children 2> /dev/null | |
f50bf50d AF |
806 | |
807 | exit | |
808 | } | |
809 | ||
40a28f08 | 810 | print_stats() { |
7f79c6f2 | 811 | if [ "$ONLY_LIST" == 'y' ] ; then return ; fi |
f588bb03 | 812 | |
c97d59cb JH |
813 | # Only count boards that completed |
814 | : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`)) | |
815 | ||
f588bb03 AF |
816 | rm -f ${donep}* ${skipp}* |
817 | ||
818 | if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then | |
033220e7 | 819 | ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/` |
b86a475c JH |
820 | ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done` |
821 | ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'` | |
033220e7 | 822 | WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/` |
b86a475c JH |
823 | WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done` |
824 | WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'` | |
c97d59cb JH |
825 | else |
826 | # Remove the logs for any board that was interrupted | |
827 | rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR | |
f588bb03 AF |
828 | fi |
829 | ||
08510204 | 830 | : $((TOTAL_CNT -= ${SKIP_CNT})) |
40a28f08 PT |
831 | echo "" |
832 | echo "--------------------- SUMMARY ----------------------------" | |
08510204 JH |
833 | if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then |
834 | echo "Boards skipped: ${SKIP_CNT}" | |
835 | fi | |
40a28f08 PT |
836 | echo "Boards compiled: ${TOTAL_CNT}" |
837 | if [ ${ERR_CNT} -gt 0 ] ; then | |
b86a475c JH |
838 | echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )" |
839 | fi | |
840 | if [ ${WRN_CNT} -gt 0 ] ; then | |
841 | echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )" | |
40a28f08 PT |
842 | fi |
843 | echo "----------------------------------------------------------" | |
f2352877 | 844 | |
f50bf50d | 845 | if [ $BUILD_MANY == 1 ] ; then |
c97d59cb | 846 | kill_children |
f50bf50d AF |
847 | fi |
848 | ||
f2352877 | 849 | exit $RC |
40a28f08 | 850 | } |
7ebf7443 | 851 | |
40a28f08 | 852 | #----------------------------------------------------------------------- |
9ec49f8f | 853 | |
0777eafb WD |
854 | # Build target groups selected by options, plus any command line args |
855 | set -- ${SELECTED} "$@" | |
856 | # run PowerPC by default | |
9ec49f8f | 857 | [ $# = 0 ] && set -- powerpc |
9ec49f8f | 858 | build_targets "$@" |
f588bb03 | 859 | wait |